EDIT - bug #10198

Termremoval for OrderedTermVocabularies does not work correctly due to incorrect compareTo and
orderindex decrement

12/09/2022 12:29 PM - Andreas Miiller
Description

The termTree in OrderedTermVocabulary identifies entries via compareTo. The compareTo for OrderedTerms in the same
vocabulary works via orderindex.

The removal method first decreases the orderindex of following terms and therefore creates a duplicate (in terms of comparison) with
the term to remove, before calling terms.remove(term). Therefore the wrong term might be removed. This was not so critical as long
as there was another bug which prevented the decrement of the the following terms. Since this is fixed and since "equal" terms are
not allowed anymore in OrderedTerms this issue becomes critical now.

Related issues:
Related to EDIT - feature request #6794: Improve term structure In Progress

Associated revisions

Revision d65295b4 - 12/09/2022 12:30 PM - Andreas Miiller

fix #10198 fix term removal

Revision 6b68bfb9 - 12/14/2022 01:34 PM - Katja Luther

ref #10198: implement test for moveTerm and fix move with position

Revision 4356940e - 12/19/2022 02:03 PM - Andreas Miiller

ref #10198 use more intuitive parameter names and cleanup

Revision 2e748910 - 12/19/2022 02:04 PM - Andreas Miiller
ref #10198 revert 6b68bfb9 (before and after handling in moveTerm)

History

#1 - 12/09/2022 12:31 PM - Andreas Miiller

- Status changed from New to Resolved

Applied in changeset cdmlib|d65295b4a60c6f5ce745eb3c07fc4cda88b8c418.

#2 - 12/09/2022 12:36 PM - Andreas Miiller

- Related to feature request #6794: Improve term structure added

#4 - 12/09/2022 02:00 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

Can you please review?

This should include checking if term handling (especially removal) in vocabularies still works as expected in TaxEditor. Please also check correctness
of orderindex after removal. But have in mind, that orderindex probably did not work correctly before so there might be missing numbers (or even
duplicates) in existing databases.

Please also check the call hierarchy of OrderedTermBase.removeTerm(term). There are 4 methods calling it in cdmlib (any in TaxEditor?). 2 of them

tests which are not problematic. 2 of them delete or move methods that you have maybe written. Are they covered by tests (I have not checked)? If
not, can you verify that they (still) work as expected?
#5 - 12/09/2022 02:48 PM - Katja Luther

Andreas Muller wrote in #note-4:

Can you please review?

This should include checking if term handling (especially removal) in vocabularies still works as expected in TaxEditor. Please also check
correctness of orderindex after removal. But have in mind, that orderindex probably did not work correctly before so there might be missing
numbers (or even duplicates) in existing databases.

Please also check the call hierarchy of OrderedTermBase.removeTerm(term). There are 4 methods calling it in cdmlib (any in TaxEditor?). 2 of

them tests which are not problematic. 2 of them delete or move methods that you have maybe written. Are they covered by tests (I have not
checked)? If not, can you verify that they (still) work as expected?

The delete method is covered by a test, but not the move method. | will implement a test.

#6 - 12/14/2022 01:49 PM - Katja Luther

Katja Luther wrote in #note-5:

Andreas Muller wrote in #note-4:
Can you please review?
This should include checking if term handling (especially removal) in vocabularies still works as expected in TaxEditor. Please also check
correctness of orderindex after removal. But have in mind, that orderindex probably did not work correctly before so there might be missing
numbers (or even duplicates) in existing databases.
Please also check the call hierarchy of OrderedTermBase.removeTerm(term). There are 4 methods calling it in cdmlib (any in TaxEditor?).

2 of them tests which are not problematic. 2 of them delete or move methods that you have maybe written. Are they covered by tests (I
have not checked)? If not, can you verify that they (still) work as expected?

The delete method is covered by a test, but not the move method. | will implement a test.

Added a test for moveTerm, while implementing this test | recognized that the implementation for move with a position was not correct, this is also
fixed with the last commit.

#7 - 12/16/2022 08:11 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

Also tested move and delete in TaxEditor.
@AM: Please review the move with position method.

#8 - 12/19/2022 01:32 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

Katja Luther wrote in #note-7:

Also tested move and delete in TaxEditor.
@AM: Please review the move with position method.

| do not really understand the change. Why should TermMovePosition.AFTER be the same as inserting the term above and BEFORE the same as
inserting it below.

| also had problems to move terms in TaxEditor. They never ended up where | exptected them to occur though the position where they ended up was
according to the DB orderIndex finally. So it is not a Ul issue but an issue how BEFORE and AFTER are evaluated IMO.

#9 - 12/19/2022 01:55 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

| debugged now in TaxEditor with rem_conf_am NamedArea voc "Test sorting". Moving "Europe2" below Land3 (eclipse
ViewerDropAdapter.LOCATION_AFTER and parent UUID 3c78631 which is Land3) resulted in "Europe2" being above Land3 (below Land2) with
orderindex between Land2 and Land3 in the DB. This can not be true.
| will revert the changes and try again.

#10 - 12/19/2022 03:39 PM - Andreas Miiller
- Priority changed from Highest to Priority14
- % Done changed from 70 to 90

Moving in TaxEditor now works as expected.

There is still an issue that orderindex misses some numbers in between when moving a term from one position to another in the same vocabulary.
But as the order in general is still correct and as we will very soon move to handle order like in term tree we may neglect this issue for now.

#11 - 01/04/2023 12:22 AM - Andreas Miiller
- Status changed from Resolved to Closed

- % Done changed from 90 to 100

Andreas Miiller wrote in #note-10:
Moving in TaxEditor now works as expected.
There is still an issue that orderindex misses some numbers in between when moving a term from one position to another in the same

vocabulary.
But as the order in general is still correct and as we will very soon move to handle order like in term tree we may neglect this issue for now.

| added SQL queries to #6794#note-48 for further checking issues in existing data. This will be handled within #6974. So we can close this ticket here.
